import java.util.LinkedList;

class Graph {

	// Lnge des Graphen (genauer: l-1)
	private int l;
	// Speichert die Kanten im Array
	private Kante A[];
	// Ungefhre Anzahl der Zustnde
	static final int maxLnge = 20;
   
	public Graph() { A = new Kante[maxLnge]; l = 0; }

	/** Fgt eine Kante in den Graph ein (an Stelle l des Arrays)
	 * @param x ist Kante(Tupel1,Tupel2), die in den Graph eingefgt
	 * werden soll. */
	public void einfgen(Kante x) {
		for(int i = 0; i < l; i++) if (A[i].equals(x)) return;
		if(l >= maxLnge) throw new RuntimeException("Graph zu gro.");
		A[l++] = x; }

	/** berprft, ob eine Kante bereits im Graph enthalten ist
	 * @param x ist Kante, die im Graph gesucht werden soll
	 * @return boolean... true, wenn enthalten, false, sonst */
	public boolean istenthalten(Kante x) {
		for(int i=0; i<l; i++) if (A[i].equals(x)) return true;
		return false; }

	/** Liefert die Nachfolgertupel in einer Liste
	 * @param t ist Tupel, von dem die Nachfolgertupel in einer
	 * Liste gespeichert werden
	 * @return LinkedList mit den Nachfolgertupeln */
	public LinkedList gibNachfolgerTupel(Tupel t) {
		LinkedList ll = new LinkedList();
		for(int i=0; i<l; i++) if (A[i].v.equals(t)) ll.add(A[i].n);
		return ll; }

	/** Lscht Kante aus einem Graphen (wird nicht verwendet)
	 * @param x ist Kante, die aus dem Graph gelscht werden soll */
	public void lschen(Kante x) {
		for(int i=0; i<l; i++) if (A[i].equals(x)) {
			for(int k=i; k<l-1; k++) A[k].equals(A[k+1]);
			l--;
			return; } }

	/** Liefert die (Array-)Lnge eines Graphen
	 * @return Array-Lnge des Graphen */
	public int length() {
		return l-1; }

	/** @return Die Kante im Graphen an Position i im Array
	 * @param i int. Array-Position i soll zurckgegeben werden */
	public Kante atPos(int i) {
		return A[i]; }

	/** @return int. Die Anzahl der Knoten des Graphen */
	public int anzKnoten() {
		int anzKnoten = 0;
		for (int i = 0; i < l; i++) {
			anzKnoten+=1;		// pro Nachfolger 1 addieren
			anzKnoten-=wievieleNachfolgerenthalten(A[i].n,i); }
			// subtrahieren, wenn nachfolger mehrfach
	   return ++anzKnoten;	}	// Wurzel noch addieren

	/** @return Die Anzahl der Nachfolger eines Tupels
	 * @param n ist Tupel, von dem die Anzahl der 
	 * Nachfolgertupel gezhlt werden soll 
	 * @param a ist int und ist die Indizesposition von n sein*/
	public int wievieleNachfolgerenthalten(Tupel n, int a) {
		int count = 0;
		for(int i = ++a; i < l; i++) if (A[i].n.equals(n)) count++;
		return count; }  	 

	/** @param n ist Tupel, von dem die Position
	 * im Graph gesucht werden soll 
	 * @return int-Wert der Indizes-Position des Tupels*/
	public int pos(Tupel n) {
		for(int i = 0; i < l; i++) if (A[i].n.equals(n)) return i;
		return -1; }  	 
	
	/** Durchluft einen Graph mit der Breitensuche
	 * (Algorithmus aus der Vorlesung)
	 * @return Graph, der nur die BFS-Kanten enthlt */
	public Graph bfs() {
		LinkedList S = new LinkedList();
		Graph gr = new Graph();
		S.add(A[0].v);
		A[0].v.g = true; A[0].v.n = false;
		
		while (!S.isEmpty()) {
			Tupel r = (Tupel) S.removeFirst();
			r.b = true;
			LinkedList l1 = gibNachfolgerTupel(r);
			while (!l1.isEmpty()) {
				Tupel w = (Tupel) l1.removeFirst();
				if (w.n) {
					w.g = true; w.n = false;
					S.add(w);
					w.vg = r; // Knnte man auch weglassen
					gr.einfgen(new Kante(r,w)); } } }
			return gr; }
			
	public LinkedList weg() {
		LinkedList weg = new LinkedList();
		Tupel temp = (A[l-1].n);
		weg.add(temp);
		while (temp.vg != null) {
			weg.addFirst(temp.vg);
			temp = temp.vg; }
		return weg;
	}
}