import java.util.ListIterator;

public class KMZW {

	// Tupel = (K,M,Z,W) mit jeweiligen Boolean-Werten
	static Tupel s  = new Tupel(0,0,0,0);
	// Graph fr mit generateGraph konstruierte Lsung
	static Graph g = new Graph();

	/** generateGraph generiert rekursiv in der Reihenfolge:
	 * (K,!M,Z,W),(!K,!M,Z,W),(K,!M,!Z,W),(K,!M,Z,!W)
	 * aus allen Kanten, auer solchen, die es im Graph schon gibt, einen Graph
	 * @param t1 ist Vorgngertupel von t2
	 * @param t2 ist Tupel auf dem rekursiv generateGraph angewandt wird */
	public static void generateGraph(Tupel t1, Tupel t2) {
		if (t2.equals(new Tupel(1,1,1,1))) return;
		Tupel temp = t2;
		// Der Mann fhrt alleine im Boot
		Tupel temp1 = new Tupel(temp.k,!temp.m,temp.z,temp.w);
		int pos = (g.pos(temp1));
		if (pos!=-1) temp1 = g.atPos(pos).n;  
		if (!conflict(temp1) && !temp1.equals(t1) && !g.istenthalten(new Kante(temp,temp1))) {
			g.einfgen(new Kante (temp,temp1)); generateGraph(temp,temp1); }
		// Der Mann fhrt mit dem Kohlkopf im Boot
		if (temp.k == temp.m) {
			Tupel temp2 = new Tupel(!temp.k,!temp.m,temp.z,temp.w);
			pos = (g.pos(temp2));
			if (pos!=-1) temp2 = g.atPos(pos).n;  
			if (!conflict(temp2) && !temp2.equals(t1) && !g.istenthalten(new Kante(temp,temp1))) {
				g.einfgen(new Kante (temp,temp2));	generateGraph(temp,temp2); } }
		// Der Mann fhrt mit der Ziege im Boot
		if (temp.z == temp.m) {
			Tupel temp3 = new Tupel(temp.k,!temp.m,!temp.z,temp.w);
			pos = (g.pos(temp3));
			if (pos!=-1) temp3 = g.atPos(pos).n;  
			if (!conflict(temp3) && !temp3.equals(t1) && !g.istenthalten(new Kante(temp,temp1))) {
				g.einfgen(new Kante (temp,temp3));	generateGraph(temp,temp3); } }
		// Der Mann fhrt mit dem Wolf im Boot
		if (temp.w == temp.m) {
			Tupel temp4 = new Tupel(temp.k,!temp.m,temp.z,!temp.w);
			pos = (g.pos(temp4));
			if (pos!=-1) temp4 = g.atPos(pos).n;  
			if (!conflict(temp4) && !temp4.equals(t1) && !g.istenthalten(new Kante(temp,temp1))) {
				g.einfgen(new Kante (temp,temp4));	generateGraph(temp,temp4); } } }
				
/*	public static void generateGraph(Tupel t) {
		if (t.equals(new Tupel(1,1,1,1))) return;
		Tupel temp = t;
		// Der Mann fhrt alleine im Boot
		Tupel temp1 = new Tupel(temp.k,!temp.m,temp.z,temp.w);
		int pos = (g.pos(temp1));
		if (pos!=-1) temp1 = g.atPos(pos).v;  
		if (!conflict(temp1) && !g.istenthalten(new Kante(temp,temp1))) {
			g.einfgen(new Kante (temp,temp1)); generateGraph(temp1); }
		// Der Mann fhrt mit dem Kohlkopf im Boot
		if (temp.k == temp.m) {
			Tupel temp2 = new Tupel(!temp.k,!temp.m,temp.z,temp.w);
			pos = (g.pos(temp2));
			if (pos!=-1) temp2 = g.atPos(pos).n;  
			if (!conflict(temp2) && !g.istenthalten(new Kante(temp,temp2))) {
				g.einfgen(new Kante (temp,temp2));	generateGraph(temp2); } }
		// Der Mann fhrt mit der Ziege im Boot
		if (temp.z == temp.m) {
			Tupel temp3 = new Tupel(temp.k,!temp.m,!temp.z,temp.w);
			pos = (g.pos(temp3));
			if (pos!=-1) temp3 = g.atPos(pos).n;
			if (!conflict(temp3) && !g.istenthalten(new Kante(temp,temp3))) {
				g.einfgen(new Kante (temp,temp3));	generateGraph(temp3); } }
		// Der Mann fhrt mit dem Wolf im Boot
		if (temp.w == temp.m) {
			Tupel temp4 = new Tupel(temp.k,!temp.m,temp.z,!temp.w);
			pos = (g.pos(temp4));
			if (pos!=-1) temp4 = g.atPos(pos).n;  
			if (!conflict(temp4) && !g.istenthalten(new Kante(temp,temp4))) {
				g.einfgen(new Kante (temp,temp4));	generateGraph(temp4); } } }
*/
	public static boolean conflict(Tupel t) {
		// Konflikt, wenn Ziege und Kohlkopf auf anderem Ufer als Mann
		if (t.k == t.z && t.z == !t.m) { return true; }
		// Konflikt, wenn Wolf und Ziege auf anderem Ufer als Mann
		if (t.w == t.z && t.z == !t.m) { return true; }
		return false; }	// Kein Konflikt

	public static void main(String[] args) {
		generateGraph(s,s);
		System.out.println("Konstruierter Graph vor der BFS:\n");
		for (int i = 0; i <= g.length(); i++)
			System.out.println("\t"+g.atPos(i)+"\t"+i);
		
		System.out.println("\nAnzahl der Kanten:\t"+(g.length()+1));
		System.out.println("Anzahl der Knoten:\t"+g.anzKnoten()+"\n");
		Graph g2 = g.bfs();
		System.out.println("Konstruierter Graph nach der BFS:\n");
		for (int i = 0; i <= g2.length(); i++)
			System.out.println("\t"+g2.atPos(i)+"\t"+i);
		System.out.println("\nAnzahl der Kanten:\t"+(g2.length()+1));
		System.out.println("Anzahl der Knoten:\t"+g2.anzKnoten()+"\n");
		System.out.println("Weg, der zur Lsung fhrt:\n");
		int count = 0;
		ListIterator li = g2.weg().listIterator();
		while (li.hasNext())
			System.out.println(++count+". "+li.next()); }
}